%% Importing Data
[file,path] = uigetfile('*.*','Input Data');
filename = fullfile(path,file);
delimiter = '\t';
startRow = 7;
formatSpec = '%f%f%f%f%f%[^\n\r]';
fileID = fopen(filename,'r');
textscan(fileID, '%[^\n\r]', startRow-1, 'ReturnOnError', false);
dataArray = textscan(fileID, formatSpec, 'Delimiter', delimiter, 'ReturnOnError', false);
fclose(fileID);
Time = dataArray{:, 1};
Potential = dataArray{:, 2};
Angle = dataArray{:, 3};
Velocity = dataArray{:, 4};
Acceleration = dataArray{:, 5};
clearvars filename delimiter startRow formatSpec fileID dataArray ans;

%% Calculating Flux
Potential = Potential - mean(Potential);
Flux = cumtrapz(Potential);

%% Peaks of EMF Potential and Angle


[pks1,locs1] = findpeaks(Angle);
PkAng = pks1;
[pks2,locs2] = findpeaks(-Angle);
PkAngn = pks2;
[pks3,locs3] = findpeaks(Potential);
PkPot = pks3;
[pks4,locs4] = findpeaks(-Potential);
PkPotn = pks4;


if locs1(1)<locs2(1);
    a=1;
PkAngLeng = length(PkAng);
PkAngnLeng = length(PkAngn);
AngDiff = PkAngLeng-PkAngnLeng;
if AngDiff > 0
    for b=1:length(PkAngn)
    MeanAng(a) = PkAng(b) + PkAngn(b)/2;
    AngTime(a) = locs1(b) + locs2(b)/2;
    a=a+1;
end;
elseif AngDiff < 0
    for b=1:length(PkAng)
    MeanAng(a) = PkAng(b) + PkAngn(b)/2;
    AngTime(a) = locs1(b) + locs2(b)/2;
    a=a+1;
end;
else
    for b=1:length(PkAng)
    MeanAng(a) = PkAng(b) + PkAngn(b)/2;
    AngTime(a) = locs1(b) + locs2(b)/2;
    a=a+1;
end;
end
elseif locs1(1)>locs2(1);
    a=1;
PkAngLeng = length(PkAng);
PkAngnLeng = length(PkAngn);
AngDiff = PkAngLeng-PkAngnLeng;
if AngDiff > 0
    for b=1:length(PkAngn)-1
    MeanAng(a) = PkAng(b) + PkAngn(b+1)/2;
    AngTime(a) = locs1(b) + locs2(b+1)/2;
    a=a+1;
end;
elseif AngDiff < 0
    for b=1:length(PkAng)
    MeanAng(a) = PkAng(b) + PkAngn(b+1)/2;
    AngTime(a) = locs1(b) + locs2(b+1)/2;
    a=a+1;
end;
else
    for b=1:length(PkAngn)-1
    MeanAng(a) = PkAng(b) + PkAngn(b+1)/2;
    AngTime(a) = locs1(b) + locs2(b+1)/2;
    a=a+1;
end;
end;
end;
if locs3(1)<locs4(1)
    n=1;
PkPotLeng = length(PkPot);
PkPotnLeng = length(PkPotn);
PotDiff = PkPotLeng-PkPotnLeng;
if PotDiff > 0
    for i=1:2:length(PkPotn)-1
  MeanPot(n) = (PkPot(i) + PkPot(i+1) + PkPotn(i) + PkPotn(i+1))/4;
  n=n+1;
end;
elseif PotDiff < 0
    for i=1:2:length(PkPot)-1
  MeanPot(n) = (PkPot(i) + PkPot(i+1) + PkPotn(i) + PkPotn(i+1))/4;
  n=n+1;
end;
else
    for i=1:2:length(PkPot)-1
  MeanPot(n) = (PkPot(i) + PkPot(i+1) + PkPotn(i) + PkPotn(i+1))/4;
  n=n+1;
end;
end;
elseif locs3(1)>locs4(1)
    n=1;
PkPotLeng = length(PkPot);
PkPotnLeng = length(PkPotn);
PotDiff = PkPotLeng-PkPotnLeng;
if PotDiff > 0
    for i=1:2:length(PkPotn)-2
  MeanPot(n) = (PkPot(i) + PkPot(i+1) + PkPotn(i+1) + PkPotn(i+2))/4;
  n=n+1;
end;
elseif PotDiff < 0
    for i=1:2:length(PkPot)-1
  MeanPot(n) = (PkPot(i) + PkPot(i+1) + PkPotn(i+1) + PkPotn(i+2))/4;
  n=n+1;
end;
else
    for i=1:2:length(PkPotn)-2
  MeanPot(n) = (PkPot(i) + PkPot(i+1) + PkPotn(i+1) + PkPotn(i+2))/4;
  n=n+1;
end;
end;
end;

%% Graphing Data


EMF_Potential = Potential;
Angular_Velocity = Velocity;
Angular_Acceleration = Acceleration;


figure('Name','All Data');
subplot(3,2,1);
plot(Time,EMF_Potential,'DisplayName','EMF_Potential');hold on;plot(Time,Flux,'DisplayName','Flux');plot(Time,Angle,'DisplayName','Angle');plot(Time,Angular_Velocity,'DisplayName','Angular_Velocity');plot(Time,Angular_Acceleration,'DisplayName','Angular_Acceleration');hold off;
xlabel('Time(s)');
ylabel('Magnitude');
lgd = legend('EMF Potential(mV)','Flux(Wb)','Angle(rad)','Angular Velocity(rad/s)','Angular Acceleration(rad/s)','Orientation','horizontal','Position',[125.0 306.5 0.1 0.1]);
lgd.FontSize = 10;
title('All Data Against Time');
xlim([10 20]);


subplot(3,2,2);
plot(Time,Angle,'.-');
xlabel('Time(s)');
ylabel('Angle(rad)');
title('Angle Against Time');

subplot(3,2,3);
plot(Time,Angular_Velocity,'.-');
xlabel('Time(s)');
ylabel('Angular Velocity(rad/s)');
title('Angular Velocity Against Time');

subplot(3,2,4);
plot(Time,EMF_Potential,'.-');
xlabel('Time(s)');
ylabel('EMF Potential(mV)');
title('EMF Potential Against Time');

subplot(3,2,5);
plot(Time,Flux,'.-');
xlabel('Time(s)');
ylabel('Flux(Wb)');
title('Flux Against Time');

subplot(3,2,6);
plot(Time, Angular_Acceleration,'.-');
xlabel('Time(s)');
ylabel('Angular Acceleration (rad/s)');
title('Angular Acceleration Against Time');

%% %% Fit: 'Maxiumum EMF Potential Against Maxiumum Angle'.
if length(MeanAng)>length(MeanPot)
    MeanAng(end)=[]
    [xData2, yData2] = prepareCurveData( MeanAng, MeanPot );

% Set up fittype and options.
ft2 = fittype( 'poly1' );

% Fit model to data.
[fitresult2, gof2] = fit( xData2, yData2, ft2 );

% Plot fit with data.
figure( 'Name', 'Maxiumum EMF Potential Against Maxiumum Angle' );
h2 = plot( fitresult2, xData2, yData2);
h2(1).MarkerSize=15;
legend( h2, 'Maxiumum EMF Potential Against Maxiumum Angle', 'Linear Fit', 'Location', 'NorthEast' );
title('Maxiumum EMF Potential Against Maxiumum Angle');
% Label axes
xlabel 'Maxiumum Angle(rad)'
ylabel 'Maxiumum EMF Potential(mV)'
grid on
elseif length(MeanAng)<length(MeanPot)
    MeanPot(end)=[]
    [xData2, yData2] = prepareCurveData( MeanAng, MeanPot );

% Set up fittype and options.
ft2 = fittype( 'poly1' );

% Fit model to data.
[fitresult2, gof2] = fit( xData2, yData2, ft2 );

% Plot fit with data.
figure( 'Name', 'Maximum EMF Potential Against Maximum Angle' );
h2 = plot( fitresult2, xData2, yData2);
h2(1).MarkerSize=15;
legend( h2, 'Maxiumum EMF Potential Against Maxiumum Angle', 'Linear Fit', 'Location', 'NorthEast' );
title('Maxiumum EMF Potential Against Maxiumum Angle');
% Label axes
xlabel 'Maxiumum Angle(rad)'
ylabel 'Maxiumum EMF Potential(mV)'
grid on
else
    [xData2, yData2] = prepareCurveData( MeanAng, MeanPot );

% Set up fittype and options.
ft2 = fittype( 'poly1' );

% Fit model to data.
[fitresult2, gof2] = fit( xData2, yData2, ft2 );

% Plot fit with data.
figure( 'Name', 'Maxiumum EMF Potential Against Mean Angle' );
h2 = plot( fitresult2, xData2, yData2);
h2(1).MarkerSize=15;
legend( h2, 'Maximum EMF Potential Against Maximum Angle', 'Linear Fit', 'Location', 'NorthEast' );
title('Maximum EMF Potential Against Maximum Angle');
% Label axes
xlabel 'Maximum Angle(rad)'
ylabel 'Maximum EMF Potential(mV)'
grid on
end

%% Fit: 'Maximum Angle Against Time'.
[xData1, yData1] = prepareCurveData( AngTime, MeanAng );

% Set up fittype and options.
ft1 = fittype( 'poly1' );

% Fit model to data.
[fitresult1, gof1] = fit( xData1, yData1, ft1 );

% Plot fit with data.
figure( 'Name', 'Maximum Angle Against Time' );
h1 = plot( fitresult1, xData1, yData1);
h1(1).MarkerSize=15;
legend( h1, 'Maximum Angle Against Time', 'Linear Fit', 'Location', 'NorthEast' );
title('Maximum Angle Against Time');
% Label axes
xlabel 'Time'
ylabel 'Maximum Angle(rad)'
grid on

%% Final Outputs

save('Output Variables.mat', 'Angular_Acceleration', 'Angle', 'Flux', 'EMF_Potential', 'Time', 'Angular_Velocity');
clear;
clc;
load('Output Variables.mat');
whos('-file','Output Variables.mat');